<?php
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 
 
/**
 * @file FlashRemoting.php
 * @desc Cette classe permet de renvoyer les informations necessaires au flash via AMFPHP
 *
 * @update : -
 *
 *
 */


/**
 *
 * @usage :
 * 		- fonctionne avec AMFPHP
 *		- renseigner toutes les methodes accessibles au flash dans le constructeur de la classe
--
-- Table structure for table `compteur_visite`
--

CREATE TABLE `compteur_visite` (
  `compteur` double NOT NULL default '0',
  `date` date NOT NULL default '0000-00-00',
  `time` int(9) NOT NULL default '0',
  `duree` int(9) NOT NULL default '0',
  `ip` varchar(50) NOT NULL default '0',
  PRIMARY KEY  (`ip`),
  KEY `compteur` (`compteur`,`date`),
  KEY `date` (`date`),
  KEY `duree` (`duree`),
  KEY `time` (`time`)
) TYPE=MyISAM;

INSERT INTO `nom_base`.`compteur_visite` (
`compteur` ,
`date` ,
`time` ,
`duree` ,
`ip`
)
VALUES (
'0', '0000-00-00', '0', '24', 'compteur'
);

 *
 */
class FlashRemoting
{

	private $oSqlConnection;


	// ---------------------------------------- __construct() ----------------------------------------------------
	/**
	 * @brief Constructeur de la classe. Initialise les proprietes.
	 *
	 */
	public function __construct()
	{
		$this->methodTable = array
		(
			"getDate" => array
			(
				"description" => "",
				"access" => "remote",
				"arguments" => "array",
				"returns" => "array"
			),

			"getVisitCount" => array
			(
				"description" => "",
				"access" => "remote",
				"arguments" => "array",
				"returns" => "array"
			)
		);

		// ajout des classes php
		//require_once("../../php/Mysql.php");// avec BackOffice pour afficher tous les services remoting : http://www.actionscript-facile.com/ressources/remoting-2.1.1/BackOffice/
		require_once("../php/Mysql.php");// avec application flash

		// connection à la base de données mysql
		$this->oSqlConnection = new Mysql();
	}


	/**
	 * @param -
	 * @return -
	 */
	public function getDate($oMsg)
	{
		$nTimestamp = time(); //Affiche le nombre de secondes écoulées depuis le 1er janvier 1970

		$date = date("d-m-Y");
		$heure = date("H:i:s");
		$sDateFr = $date." ".$heure;

		$aResult = array();
		$aResult["timestamp_php"] = $nTimestamp;
		$aResult["date"] = $sDateFr;
		$aResult["message"] = $oMsg;
		return $aResult;
	}



	/**
	 * @brief Récupère le nombre de visiteur sur le site actuellement, met à jour le compteur également.
	 * @param -
	 * @return -
	 */
	public function getVisitCount()
	{
		/* init des variables */
		$n_nbVisiteur = 0;
		$n_nbVisiteurToday = 0;
		$n_nbVisiteurNow = 0;

		//on recupere l adresse ip du visiteur
		if($_SERVER)
		{
			if($_SERVER['HTTP_X_FORWARDED_FOR'])
				$sIpAdress = $_SERVER['HTTP_X_FORWARDED_FOR'];
			elseif($_SERVER['HTTP_CLIENT_IP'])
				$sIpAdress = $_SERVER['HTTP_CLIENT_IP'];
			else
				$sIpAdress = $_SERVER['REMOTE_ADDR'];
		}
		else
		{
			if(getenv('HTTP_X_FORWARDED_FOR'))
				$sIpAdress = getenv('HTTP_X_FORWARDED_FOR');
			elseif(getenv('HTTP_CLIENT_IP'))
				$sIpAdress = getenv('HTTP_CLIENT_IP');
			else
				$sIpAdress = getenv('REMOTE_ADDR');
		}



		$sDate = date("Y-m-d");
		//on convertit l heure courante en minute d une journee
		$sTime = (date("H") * 60) + date("i");

		$s_sqlSelect = "SELECT compteur, date, time, duree FROM compteur_visite WHERE ip = 'compteur' LIMIT 1";
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		$o_result = $this->oSqlConnection->getObject($o_sqlResult);
		$n_nbVisiteur = $o_result->compteur;

		$iTimeConnexionRef = $o_result->time; //temps de connexion de reference
		$iDurationRef = $o_result->duree; //duree de renouvellement de reference
		$sDateBDD = $o_result->date;

		//on test si on a changé de jour
		if ( $sDate!=$sDateBDD )
		{
			$s_sqlDelete = "DELETE FROM compteur_visite WHERE ip!='compteur'";//on vide toutes les addresses ip enregistrées dans la table lors du changement de jour
			$o_sqlResult = $this->oSqlConnection->query($s_sqlDelete);
			$s_sqlUpdate = "UPDATE compteur_visite SET date='$sDate'";//on met a jour la nouvelle date dans la table
			$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
		}


		//on verifie l adresse ip du visiteur et aussi son heure de passage
		$s_sqlSelect = "SELECT compteur, date, time, duree FROM compteur_visite WHERE ip='$sIpAdress' LIMIT 1";

		// excecute la requete sql
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		// recupere le resultat renvoyee par la requete
		$o_result = $this->oSqlConnection->getObject($o_sqlResult);

		if( $o_result->compteur == NULL)
		{
			//on enregistre l adresse ip si elle est inconnu et on incremente le compteur
			$s_sqlInsert = "INSERT INTO compteur_visite (ip,time,duree) VALUES ('$sIpAdress','$sTime','$sTime')";
			$o_sqlResult = $this->oSqlConnection->query($s_sqlInsert);
			$n_nbVisiteur +=1;
			$s_sqlUpdate = "UPDATE compteur_visite SET compteur=$n_nbVisiteur WHERE ip='compteur' LIMIT 1";
			$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
		}
		else
		{
			// si l'adresse ip est connu alors verifie si sa connexion precedente est superieur a la durée
			// de renouvellement et si son heure de passage precedente incremente ou pas les connectés
			$sTimeVisit = $o_result->time;//on recupere l'heure de sa precedente connexion de notre connecté
			$sDurationVisit = $o_result->duree;//on recupere l'heure de sa precedente connexion de notre connecté

			// on verifie si sa derniere connexion ne date pas de plus que la duree de reference
			if( $iDurationRef*60 < ( $sTime - ($sDurationVisit) ) )
			{
				//si la duree de reference est depassé alors notre connecté est comptablisé
				//comme nouvelle visite et on met a jour sa nouvelle heure de passage
				$s_sqlUpdate = "UPDATE compteur_visite SET time=$sTime, duree=$sTime WHERE ip='$sIpAdress' LIMIT 1";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);

				//on cree une ligne fictive pour pouvoir le comptabiliser dans les connectés de jour
				$sIpAdressV = $sIpAdress.".".$n_nbVisiteur;
				//echo"sIpAdressV : ".$sIpAdressV;

				$s_sqlInsert ="INSERT INTO compteur_visite (ip,time,duree) VALUES ('$sIpAdressV','$sTime','$sTime')";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlInsert);

				//et on increment le compteur de visite
				$n_nbVisiteur +=1;
				$s_sqlUpdate = "UPDATE compteur_visite SET compteur=$n_nbVisiteur WHERE ip='compteur' LIMIT 1";
				$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
			}
			else
			{
				//on met a jour son heure de passage si elle est superieure a t
				if ( $sTime > ( ($sTimeVisit)-$iTimeConnexionRef ) )
				{
					$s_sqlUpdate="UPDATE compteur_visite SET time=$sTime WHERE ip='$sIpAdress' LIMIT 1";
					$o_sqlResult = $this->oSqlConnection->query($s_sqlUpdate);
				}
			}


		}


		// on compte le nb de connecté de la journée
		$s_sqlSelect = "SELECT ip FROM compteur_visite WHERE ip!='compteur'";
		// recupere le resultat de la requete SELECT
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		// retourne le nombre d'enregistrement renvoyee par la requete SELECT
		$n_nbVisiteurToday = $this->oSqlConnection->getNumRows();

		// on compte le nb de connecté
		$sTimeToday = $sTime - $iTimeConnexionRef;
		$s_sqlSelect = "SELECT ip FROM compteur_visite WHERE time >= $sTimeToday AND ip!='compteur' ";
		// recupere le resultat de la requete SELECT
		$o_sqlResult = $this->oSqlConnection->query($s_sqlSelect);
		// retourne le nombre d'enregistrement renvoyee par la requete SELECT
		$n_nbVisiteurNow = $this->oSqlConnection->getNumRows();


		$aResult = array();
		$aResult["total"] = $n_nbVisiteur;
		$aResult["today"] = $n_nbVisiteurToday;
		$aResult["now"] = $n_nbVisiteurNow;
		return $aResult;
	}



 	// -------------------------------------------------------------------------------------------------
	// ---------------------------------------- OTHER  ------------------------------------------------
	// -------------------------------------------------------------------------------------------------


 	/**
	 * @brief Destructeur de la classe
	 * Utilise pour enregistrer des messages pour le debogage, fermer les fichier ouverts en ecriture ou en lecture, realiser des operations
	 * de nettoyage des objets utilises...
	 *
	 * @param
	 * @return
	 */
	function __destruct()
	{

 	}



	// ---------------------------------------- __toString() ----------------------------------------------------
	/**
	 * @brief Determine comment la classe doit reagir lorsqu'elle est convertie en chaene de caracteres.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la representation de l'objet sous forme de chaene.
	 */
	function __toString()
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprietes de la classe et les renvoie
		foreach($this as $prop => $value) $s_classContent .= "$prop => $value <br />";

		return $s_classContent;
   	}
}

?>